/**
 * 手机号码验证
 */
define("project/scripts/account/msgVerify",function(require,exports,module){
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        gconfig = require("gconfig"),
        global = require("gconfig").global,
        layerUtils = require("layerUtils"),
        utils = require("utils"),
        validatorUtil = require("validatorUtil"),
        startCountDown = null,
        cur_value,
        shellPlugin = require("shellPlugin"),
        _pageId = "#account_msgVerify";
    var psw_id = "";
    var flag =false,
    yzm_flag = false,
    sumTime1 = 0,
        steps = ["uploadimg","idconfirm","stkacct","setpwd","tpbank","risksurvey",
                 "visitsurvey","witness","success","lastsurvey"
        ],
        stepMap = {"uploadimg":"account/uploadPhoto","idconfirm":"account/personInfo",
           "stkacct":"account/signProtocol", "setpwd":"account/setPwd","tpbank":"account/thirdDepository",
           "risksurvey":"account/riskAssessment","visitsurvey":"account/openConfirm","witness":"account/videoNotice",
            "success":"account/accountResult","lastsurvey":"account/finishConfirm"
        },
        stepMap0 = {"uploadimg":"account/uploadIdCardChange"};
    /* 私有业务模块的全局变量 end */

    function init()
    {
    	//$(_pageId+" .getmsg").css("background","#e6e6e6");
    	$("#bodyContent").height($("#bodyContent").height());
    	var minheight=window.innerHeight;
    	$("#bodyContent").css({"overflow": "auto", "position": "relative","padding_bottom": "40px","min-height":minheight-40+"px"});
        
        $(".projectNo").show();
    	$(" .projectNo").text(global.projectNo);
       $(_pageId+" .vioce").attr("phone","false");
       /*发送验证码后自动互调该方法*/
        appUtils.setSStorageInfo("openChannel","new");
        window.getCode = getCode;
        var elements = _pageId +" .phoneNum";
        utils.getPhoneNo(elements); // 自动获取手机号，并填充
        appUtils.setSStorageInfo("isBack", "");
        pageInit();
    }
	
    function pageInit(){
    	var versionCode = global.versionCode;
    	service.getVersion({"terminal_type":"android"},function(data){
    		if(data.error_no == 0){
    			if(versionCode < data.results[0].version){
    				if(data.results[0].enforcement == "0"){
	    				layerUtils.iAlert("APP版本过低，请前往wap.ytzq.com安装新版！",-1,function(){
	    					window.location.href = data.results[0].update_url;
	    				});
    				}
    			}
    		}else{
    			layerUtils.iMsg(-1,data.error_info);
			}
    	});
    }
    
	function bindNoSend(){
		appUtils.bindEvent($(_pageId + " .getmsg"), function() {
			return false;
		});
	}
	
	function bindSend(){
		  /* 绑定获取短信验证码事件 */
        appUtils.bindEvent($(_pageId+" .getmsg"),function(){
            var phoneNum =  $(_pageId+" .phoneNum").val();
            // 首先验证手机号
            if(/1[3-9]\d{9}/.test(phoneNum))
            {
                getSmsCode(phoneNum);  //获取验证码
            }
            else
            {
                // 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
                layerUtils.iMsg(-1,"您的手机号码输入错误！");
                return;
            }
            yzm_flag = true;
        });
	}

    function bindPageEvent(){
		/* 绑定键盘输入 */
		appUtils.bindEvent($(_pageId + " .phoneNum"), function(e) {
			var len=$(this).val().length;
			if(len==11){
				$(_pageId+" .getmsg").css("background","#D70B17");
				bindSend();
			}else{
				$(_pageId+" .getmsg").css("background","#e6e6e6");
				$(_pageId+" .cert_vioce").hide();
				window.clearInterval(startCountDown);
				$(_pageId+" .getmsg").show();  // 显示按钮
                $(_pageId+" .time").hide();  // 隐藏倒计时
				bindNoSend();
			}
		},"keyup");
		
          //  20170323语音播报验证码
        appUtils.bindEvent($(_pageId+" .vioce"),function(){
        	service.getExpire({"mobile_no" : $(_pageId+" .phoneNum").val()},function(data1){
	            var result1 = data1.results;
	            if(data1.error_no == "0"){
	            	if(result1[0].expire != "0"){
	            		if(sumTime1 > 0){
			        		layerUtils.iMsg(-1,"操作频繁，请稍后重试！");
			    			return false;
			        	}
			            //处理获取验证码时发生的动作
			            var handleCount1 = function(){
			            	sumTime1++;
			            	if(sumTime1 >= 60){
			            		sumTime1 = 0;
			            		window.clearInterval(startCountDown1);
			            	}
			            };
			            startCountDown1 = window.setInterval(function(){
			                handleCount1();
			            }, 1000);
			        	
			        	
			        	if(yzm_flag){
			    		 utils.layerTwoButton("请接听我司95341电话，收听语音验证码","取消","确认",
			                function(){
				            	yzm_flag = true;
				                return false;},
			                function(){
			               //调用接口语音平台
			                   var mac = iBrowser.pc ? "02:00:5E:00:00:14" : "",
			                   ip = iBrowser.pc ? "192.168.1.109" : "";
						        // 只有当不是 pc 时，才调用壳子获取 ip 和 mac
						        var param = {
						            // 访问接口来源标识，访问来源(默认PC) 0：pc， 2：pad， 3：手机
						            "op_way" : iBrowser.pc ? 0 : 3,
						            "mobile_no" :  $(_pageId+" .phoneNum").val(),
						            "ip" : ip,
						            "mac" : mac,
						            newapp: "2"  //标志客户是从新版App登录
						        };
						        //请求获取验证码接口
						        service.getVoiceCode(param,function(data){
						            var error_no = data.error_no;
						            var error_info = data.error_info;
						            var result = data.results;
						            if(error_no == "0")
						            {
						            	
						            }else{
						            	layerUtils.iMsg(-1,error_info);
						            }
			                    })
			                  yzm_flag = false;
			                });
			        		
			        	}else{
			        		var phoneNum =  $(_pageId+" .phoneNum").val();
			        		if(phoneNum == ""){
			        			layerUtils.iMsg(-1,"请输入手机号码！");
			        		}/*else{
			        			layerUtils.iMsg(-1,"请先获取验证码");
			        		}*/
			        		yzm_flag = true;
			        	}  
	            	}else{
	            		layerUtils.iMsg(-1,"请先点击发送验证码！");
	            	}
	            }else{
	            	layerUtils.iMsg(-1,data1.error_info);
	            }
        	});
	    });

        /* 绑定返回事件 */
        appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
            appUtils.pageBack();
        });

        /* 绑定退出按钮*/
        appUtils.bindEvent($(_pageId+" .header .icon_close"),function(){
            utils.layerTwoButton("退出系统？","确认","取消",function(){
                    require("shellPlugin").callShellMethod("closeAppPlugin",null,null);  // 退出程序
                },
                function(){return false;});
        });

        /* 限制输入验证码在IOS的长度 */
        appUtils.bindEvent($(_pageId+" .mobileCode"),function(){
            utils.dealIPhoneMaxLength(this,6); //处理iphone兼容
        });

        /* 限制手机号在IOS上的长度 */
        appUtils.bindEvent($(_pageId+" .phoneNum"),function(){
            utils.dealIPhoneMaxLength(this,11); //处理iphone兼容
        });

        /* 电话号码失去焦点事件 */
//		appUtils.bindEvent($(_pageId+" .phoneNum"),function(){
//			var phoneNum =  $(_pageId+" .phoneNum").val();
//			if(phoneNum && !validatorUtil.isMobile(phoneNum)){
//				layerUtils.iMsg(-1,"您的手机号码输入错误！");
//			}
//		},"blur");

        /* 绑定获取短信验证码事件 */
        appUtils.bindEvent($(_pageId+" .getmsg"),function(){
            var phoneNum =  $(_pageId+" .phoneNum").val();
            // 首先验证手机号
            if(/1[3-9]\d{9}/.test(phoneNum))
            {
                getSmsCode(phoneNum);  //获取验证码
            }
            else
            {
                // 手机号没通过前端校验，弹出提示，并终止发送验证码的过程
                layerUtils.iMsg(-1,"您的手机号码输入错误！");
                return;
            }
            yzm_flag = true;
        });

        /* 下一步(继续开户)*/
        appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn") ,function(){
            if($(_pageId+" .phoneNum").val().length == 0)
            {
                layerUtils.iMsg(-1,"请输入手机号！");
                return;
            }
            if($(_pageId+" .mobileCode").val().length == 0)
            {
                layerUtils.iMsg(-1,"请输入验证码！");
                return;
            }
            appUtils.clearSStorage();// 清除session值
            checkSmsCode();  //验证码校验
        });
    }

    function destroy()
    {
        // 清除计时器
        if(startCountDown != null)
        {
            window.clearInterval(startCountDown);
        }
        $(_pageId+" .getmsg").show();  // 显示按钮
        $(_pageId+" .cert_notice").hide();  // 隐藏验证码已发出提示
        $(_pageId+" .time").hide();  // 隐藏倒计时
        $(_pageId+" .phoneNum").val("");  //清除手机号
        $(_pageId+" .mobileCode").val("");  // 清除验证码
        $(_pageId+" .vioce").attr("phone","false");
         $(".projectNo").hide();
        service.destroy();
    }

    /* 壳子获取验证码自动填充 */
    function getCode(data)
    {
        if(data)
        {
            $(_pageId+" .phoneNum").val(data);
        }
    }

    /* 获取验证码 */
    function getSmsCode(phoneNum)
    {
        var mac = iBrowser.pc ? "02:00:5E:00:00:14" : "",
            ip = iBrowser.pc ? "192.168.1.109" : "";
        // 只有当不是 pc 时，才调用壳子获取 ip 和 mac
        if(!iBrowser.pc)
        {
            require("shellPlugin").callShellMethod("getIpMacPLugin",function(data){
                data = data.split("|");
                mac = data[0];
                ip = data[1];
            },null);
        }
        // 将 mac 和 ip 保存到 sessionStorage 里面
        appUtils.setSStorageInfo("ip",ip);
        appUtils.setSStorageInfo("mac",mac);
        var param = {
            // 访问接口来源标识，访问来源(默认PC) 0：pc， 2：pad， 3：手机
            "op_way" : iBrowser.pc ? 0 : 3,
            "mobile_no" : phoneNum,
            "ip" : ip,
            "mac" : mac,
            newapp: "2"  //标志客户是从新版App登录
        };
        //请求获取验证码接口
        service.getSmsCode(param,function(data){
            var error_no = data.error_no;
            var error_info = data.error_info;
            var result = data.results;
            if(error_no == "0")
            {
                //后台如果返回ip地址，则本地存储用户ip地址
                if(result[0] && result[0].ip)
                {
                    appUtils.setSStorageInfo("ip",result[0].ip);
                }
                // 计时器
                var sumTime = 120;
                //处理获取验证码时发生的动作
                var handleCount = function(){
                    // 获取验证码之后按钮隐藏
                    $(_pageId+" .getmsg").hide();
                    // 显示倒计时
                    $(_pageId+" .time").show();
                  
                    $(_pageId+" .time").text(sumTime--+"秒后重发");
                    //倒计时小于等于90s显示语音验证码按钮
                    if(sumTime < 90){
                    	$(_pageId+" .cert_vioce").show();
                    }
                };
                handleCount();
                startCountDown = window.setInterval(function(){
                    handleCount();
                }, 1000);
                // 120 秒之后清除计时器
                var clearCountDown = setTimeout(function(){
                    // 显示按钮
                    $(_pageId+" .getmsg").show();
                    // 隐藏倒计时
                    $(_pageId+" .time").hide();
//                  20170323  添加语音验证码提示
                    $(_pageId+" .vioce").attr("phone","true");
                    $(_pageId+" .cert_notice").hide();
                    $(_pageId+" .time").text(120);
                    window.clearInterval(startCountDown);
                },121000);
                //发送完验证码后，通过判断输入手机号是否一致，否则重新发送验证码
                var c_phoneNum =phoneNum;
                appUtils.bindEvent($(_pageId+" .phoneNum"),function(){
                    c_phoneNum =$(_pageId+" .phoneNum").val();
                    if(/1[3-9]\d{9}/.test(phoneNum)&&/1[3-9]\d{9}/.test(c_phoneNum))
                    {
                        //用户两次输入的手机号不同，重新获取验证码
                        if(c_phoneNum!=phoneNum)
                        {
                            clearInterval(startCountDown);   //清除定时器
                            clearTimeout(clearCountDown);
                            $(_pageId+" .getmsg").show();  // 显示按钮
                            $(_pageId+" .time").hide();  // 隐藏倒计时
                        }
                    }
                },"input");
            }
            else
            {
              // 20170323  添加语音验证码提示
		       $(_pageId+" .vioce").attr("phone","true");
              layerUtils.iAlert(error_info,-1);
               return false; 
            }
        });
    }

    /* 提交验证码校验    生产渠道信息uehqGGjUYeATlnsPJE8j4A==  同花顺：M9quFWXQc7rddLc4CjUeaQ==  测试渠道信息/TP9g9+dDePsMbfgvFLPvg==*/
    function checkSmsCode()
    {
        var param = {
            "mobile_no" : $(_pageId+" .phoneNum").val(),
            "mobile_code" : $(_pageId+" .mobileCode").val(),
            "login_flag" : 0 , // 登录业务标准，新开户：0 转户：  1 
            newapp: "2"  //标志客户是从新版App登录 
        };
        /*调用验证码校验接口*/
        service.checkSmsCode(param,function(data){
            console.log(data);
            var error_no = data.error_no;
            var error_info = data.error_info;
            var result = data.results;
            if(error_no == "0" && result.length != 0)
            {
               
                // channel_branchno保存到session
                if(result[0].channel_branchno)
                {
                    appUtils.setSStorageInfo("channel_branchno",result[0].channel_branchno);
                }
                // user_id保存到session
                if(result[0].user_id)
                {
                    appUtils.setSStorageInfo("user_id",result[0].user_id);
                }
                // 身份证号保存到session
                if(result[0].idno)
                {
                    appUtils.setSStorageInfo("idCardNo",result[0].idno);
                }
                //手机号保存到session
                if(result[0].mobileno)
                {
                    appUtils.setSStorageInfo("mobileNo",result[0].mobileno);
                }
                // 将客户姓名保存到 session 中
                if(result[0].custname)
                {
              
                    appUtils.setSStorageInfo("custname",result[0].custname);
                }
                // 签发机关保存到session
                if(result[0].policeorg)
                {
                    appUtils.setSStorageInfo("policeorg",result[0].policeorg);
                }
                // 证件地址保存到session
                if(result[0].native)
                {
                    appUtils.setSStorageInfo("native",result[0].native);
                }
                // 联系地址保存到session
                if(result[0].addr)
                {
                    appUtils.setSStorageInfo("addr",result[0].addr);
                }
                // 起始期限保存到session
                if(result[0].idbegindate)
                {
                    appUtils.setSStorageInfo("idbegindate",result[0].idbegindate);
                }
                // 结束期限保存到session
                if(result[0].idenddate)
                {
                    appUtils.setSStorageInfo("idenddate",result[0].idenddate);
                }
                // 邮编保存到session
                if(result[0].postid)
                {
                    appUtils.setSStorageInfo("postid",result[0].postid);
                }
                // 职业保存到session
                if(result[0].profession_code)
                {
                    appUtils.setSStorageInfo("profession_code",result[0].profession_code);
                }
                // 学历保存到session
                if(result[0].edu)
                {
                    appUtils.setSStorageInfo("edu",result[0].edu);
                }
                // 行业保存到session
                 if(result[0].occupation)
                {
                    appUtils.setSStorageInfo("occupation",result[0].occupation);
                }
                // 将 clientinfo 保存到 session 中，用于解决壳子上传照片的权限问题
                if(result[0].clientinfo)
                {
                    appUtils.setSStorageInfo("clientinfo",result[0].clientinfo);
                }
                // 将 jsessionid 保存到 session 中，用于解决壳子上传照片的权限问题
                if(result[0].jsessionid)
                {
                    appUtils.setSStorageInfo("jsessionid",result[0].jsessionid);
                }
                // 将佣金id保存到session
                if(result[0].commission)
                {
                    appUtils.setSStorageInfo("commission",result[0].commission);
                }
                // 将佣金值保存到session
                if(result[0].commissionname)
                {
                    appUtils.setSStorageInfo("commissionname",result[0].commissionname);
                }
                // 将营业部Id保存到session
                if(result[0].branchno)
                {
                    appUtils.setSStorageInfo("branchno",result[0].branchno);
                }
                // 将营业部名称保存到session
                if(result[0].branchname)
                {
                    appUtils.setSStorageInfo("branchname",result[0].branchname);
                }
                // 将省份保存到session
                if(result[0].provincename)
                {
                    appUtils.setSStorageInfo("provincename",result[0].provincename);
                }
                // 将城市保存到session
                if(result[0].cityname)
                {
                    appUtils.setSStorageInfo("cityname",result[0].cityname);
                }
                 // 将回访开关保存到session
                if(result[0].isNeedConfirm)
                {
                    appUtils.setSStorageInfo("isNeedConfirm",result[0].isNeedConfirm);
                }
                // 保存经纪人编码
                if(result[0].recommendno){
                    appUtils.setSStorageInfo("recommendno", result[0].recommendno);
                }   
                
                //将工作单位保存到session
                if(result[0].workplace){
                	appUtils.setSStorageInfo("workplace", result[0].workplace);
                }
                //将职务保存到session 
                if(result[0].resign){
                	appUtils.setSStorageInfo("resign", result[0].resign);
                }
                //将诚信记录保存到session
                if(result[0].credit_record){
                	appUtils.setSStorageInfo("credit_record", result[0].credit_record);
                }
                //将邮箱保存到session
                if(result[0].email){
                	appUtils.setSStorageInfo("email", result[0].email);
                }
                //将税收身份保存到session
                if(result[0].is_tax_resident){
                	appUtils.setSStorageInfo("is_tax_resident", result[0].is_tax_resident);
                }
                //将省份保存到session
                if(result[0].province){
                	appUtils.setSStorageInfo("province", result[0].province);
                }
               //将市保存到session
                if(result[0].city){
                	appUtils.setSStorageInfo("city", result[0].city);
                }
               //将区保存到session
                if(result[0].area){
                	appUtils.setSStorageInfo("area", result[0].area);
                }
                var  opacctkind_flag = result[0].opacctkind_flag;  // 开户通道的标识，0 新开户，1 转户 , 2 理财户
                // 根据 opacctkind_flag 设置 session 中的 openChannel
                if(opacctkind_flag == 0)
                {
                    appUtils.setSStorageInfo("openChannel","new");
                }
                else
                {
                    if(opacctkind_flag == 2)
                    {
                        appUtils.setSStorageInfo("finance","finance");
                    }
                    appUtils.setSStorageInfo("openChannel","change");
                }
                //判断是否驳回，若驳回 则走驳回流程
                if(addition(result[0]))
                {
                    return false;
                }
                //未驳回，则正常走流程
                else
                {
                    nextStep(result[0], opacctkind_flag);
                }
            }
            else
            {
                $(_pageId+" .mobileCode").val("");
                layerUtils.iMsg(-1,error_info);
            }
        });
       
    	
  
    }

    /* 处理驳回补全资料的情况 */
    function addition(res)
    {
        //驳回情况：身份证正面、反面、大头像、交易密码、资金密码、三方存管、转户驳回到视频见证
        var photoParam = {"needFront" : res.need_photo_front != undefined ? res.need_photo_front : "0",
            "needBack" : res.need_photo_back != undefined ? res.need_photo_back : "0",
            "needNohat" : res.need_photo_nohat != undefined ? res.need_photo_nohat : "0",
            "needInfo_back"  : res.need_photo_back_reason,
            "needInfo_front"  : res.need_photo_front_reason
        
        };
        var pwdParam = {"needBusinessPwd" : res.need_business_password != undefined ? res.need_business_password : "0",
            "needFundPwd" : res.need_fund_password != undefined ? res.need_fund_password : "0"
        };
        var thirdParam ={"needThirdDeposit" : res.need_third_deposit != undefined ? res.need_third_deposit : "0"
        
        };
        var videoParam = {"need_video" : res.need_video != undefined ? res.need_video : "0",
             "needInfo"  :res.need_video_reason
        };
        //视频见证阶段驳回
         //a.驳回身份证照片
         var  photoFlag = {"need_videophoto_front" : res.need_videophoto_front != undefined ? res.need_videophoto_front : "0",
             "need_videophoto_back" : res.need_videophoto_front != undefined ? res.need_videophoto_back : "0",
             "videophoto_back"  :res.need_videophoto_back_reason,
             "videophoto_front"  :res.need_videophoto_front_reason
             };
          //b.驳回个人信息   
		 var  personinfoFlag = {"need_personInfo" : res.need_personInfo != undefined ? res.need_personInfo : "0",
		        "need_personInfo_reason" : res.need_personInfo_reason
		 };
        
        appUtils.setSStorageInfo("photoParam",JSON.stringify(photoParam));
        appUtils.setSStorageInfo("videoParam",JSON.stringify(videoParam));
        appUtils.setSStorageInfo("photoFlag",JSON.stringify(photoFlag));
        appUtils.setSStorageInfo("personinfoFlag",JSON.stringify(personinfoFlag));  
        
         //5.视频见证驳回补全身份证照片
         if(photoFlag["need_videophoto_front"]==1 || photoFlag["need_videophoto_back"]==1 )
        { 
            appUtils.pageInit("account/msgVerify","account/uploadPhoto",photoFlag);
            return true;
        }
         //6.视频见证驳回补全个人信息
         if(personinfoFlag["need_personInfo"]==1)
        {
           appUtils.pageInit("account/msgVerify","account/personInfo",personinfoFlag);
            return true;
        }
        // 1.补全照片
        if(photoParam["needFront"]==1 || photoParam["needBack"]==1 || photoParam["needNohat"]==1)
        {
            appUtils.pageInit("account/msgVerify","account/backUploadPhoto",photoParam);
            return true;
        }
        // 2.驳回密码设置
        if(pwdParam["needBusinessPwd"]==1 || pwdParam["needFundPwd"]==1)
        {
            appUtils.pageInit("account/msgVerify","account/backSetPwd",pwdParam);
            return true;
        }
        // 3.驳回三方存管
        if(thirdParam["needThirdDeposit"]==1)
        {
            appUtils.pageInit("account/msgVerify","account/backThirdDepository",thirdParam);
            return true;
        }
        // 4.驳回视频见证
        if(videoParam["need_video"]==1)
        { 
	        appUtils.pageInit("account/msgVerify","account/videoNotice",videoParam);
	        return true;     
        }
       
        else
        {
            return false;
        }
    }

    /* 下一步入口 */
    function nextStep(res, opacctkind_flag)
    {
        var pageCode = "";
        var currentStep = res["lastcomplete_step"];  //断点：上次走的最后一步
        appUtils.setSStorageInfo("currentStep",currentStep);
        if(currentStep && currentStep.length > 0)
        {
            var index = steps.indexOf(currentStep);
            if(index < (steps.length-1))
            {  
               
                if(currentStep=="risksurvey"){
	                 var isNeedConfirm =  appUtils.getSStorageInfo("isNeedConfirm");	
					 if(isNeedConfirm == "0" )
			         {	  //跳转到会访页面
			             currentStep = steps[index + 1];   		
			         }
			         else{
			         //跳到是视频见证页面
			            currentStep = steps[index + 2];
			          }
		         }
		        else{
		           currentStep = steps[index + 1];
		         } 
                
               
            }
            if(opacctkind_flag == "0")
            { 
		       pageCode = stepMap[currentStep];      
	        }
            else
            {
                pageCode = stepMap0[currentStep];
                if(!(pageCode && pageCode.length > 0))
                {
                    pageCode = stepMap[currentStep];
                }
            }
        }
        if(pageCode && pageCode.length > 0)
        {
            // 如果是直接跳转到 视频认证 页面，将 QQ 保存到 session 中
            if(pageCode == "account/videoNotice") {
                appUtils.setSStorageInfo("qq",res.im_code);
            }
            // 如果是直接跳转到 开户结果 页面，将资金账号、股东账户保存到 session
            if(pageCode == "account/accountResult") {
                // 将返回的 资金账号 保存到 session
                var fundAccount = null;
                // 将当后台有返回资金账号时，才保存
                if(res.fund_account != undefined && res.fund_account != "")
                {
                    fundAccount = res.fund_account;
                    /*// 不足 12 位补 0
                     if(fundAccount.length < 12)
                     {
                     // 加 0 的个数
                     var addSum = 12 - fundAccount.length;
                     for(var i = 0;i<addSum;i++)
                     {
                     fundAccount = "0" + fundAccount;
                     }
                     }*/
                    appUtils.setSStorageInfo("acct_fndacct",fundAccount);  //保存资金账号
                }
                // 将返回的股东账号存到 session 中，key 为 gdzh
                var gdzhArray = new Array(),
                    gdzhStr = "";
                // 深 A
                if(res.szaaccount != "" && res.szaaccount != undefined)
                {
                    gdzhArray.push("深A账号:"+res.szaaccount);
                }
                // 沪 A
                if(res.shaaccount != "" && res.shaaccount != undefined)
                {
                    gdzhArray.push("沪A账号:"+res.shaaccount);
                }
                // 沪 A 基金
                if(res.hacn_account != "" && res.hacn_account != undefined)
                {
                    gdzhArray.push("沪开放式基金:"+res.hacn_account);
                }
                // 深 A 基金
                if(res.zacn_account != "" && res.zacn_account != undefined)
                {
                    gdzhArray.push("深开放式基金:"+res.zacn_account);
                }
                // 将数组 gdzhArray 转换为字符串，并以 - 连接各元素
                gdzhStr = gdzhArray.join("-");
                appUtils.setSStorageInfo("gdzh",gdzhStr);
            }
            // 如果是要跳转到设置证书密码或者是安装证书的界面，检测是否需要安装证书
//          if(pageCode === "account/setPwdCertificate" ||
//              pageCode === "account/digitalCertificate"){
//              	pageCode = "account/signProtocol";  
//          }
            appUtils.pageInit("account/msgVerify",pageCode,{});
        }
        else
        {
            appUtils.pageInit("account/msgVerify","account/selDepartment",{});
        }
    }

    var msgVerify = {
        "init" : init,
        "bindPageEvent" : bindPageEvent,
        "destroy" : destroy
    };
    //暴露接口
    module.exports = msgVerify;
});