/**
 * 新开户(转户)须知
 */
define("project/scripts/account/openAccount",function(require, exports, module){ 
	// 私有业务模块的全局变量 begin
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(),  //业务层接口，请求数据
	    layerUtils = require("layerUtils"),
		shellPlugin = require("shellPlugin"),
		   _pageId = "#account_openAccount";
	// 私有业务模块的全局变量 end
	
	function init(){	
		   $(_pageId+" .header h3").html("开户须知");
		   $(_pageId+" .ness_box h5").html("开户前的准备：");
		   $(_pageId+" .ness_box span").css("color","red");
		   $(_pageId+" .step_box h5").html("三步即可开户：");
		   //pageInit();
	}
	
	  function pageInit(){
		   appUtils.clearSStorage();
		// 自动测速，选择最佳地址
		// 启动时，检查当前客户端的版本号与服务器上最新的是否一致，根据需要更新客户端，只在启动时检查
		// started 为 true 表示已启动，已启动就不检查
		if(appUtils.getSStorageInfo("started") != "true")
		{
			// 设置 session 中的 started 为 true ，表示已启动
			appUtils.setSStorageInfo("started","true");
			layerUtils.iLoading(true,'初始化版本...');
			detectUpdate();
		}
	}
	
	/* 检测更新最新版本 */
	function detectUpdate()
	{
		// 获取客户端的版本号
		var vesionStr = null;
		shellPlugin.callShellMethod("getVersionPlugin",function(data){
			vesionStr = data.version;
			// 查询服务器上最新的版本号
			var queryParam = {"terminal_type" : "android"}; // 类型
			detectNetWork();  // 检查网络
			service.getVersion(queryParam,function(data){
				if(data.error_no == 0)
				{
					if(vesionStr < data.results[0].version){
						layerUtils.iLoading(false);
						execUpdate(data);  // 更新最新版本
					}else{
						layerUtils.iLoading(false);
					}
					
				}
				else
				{
					layerUtils.iLoading(false);
				}
			},true,false);
		},function(){return false;},{});
	}
	
	/* 检测网络是否可用 */
	function detectNetWork()
	{
		// 插件中全局的断网监听也会执行，让首页的断网监听在全局断网之后执行
		setTimeout(function(){
			// 发请求之前，检测网路是否存在，存在--发请求
			shellPlugin.callShellMethod("isNetAvailablePlugin",function(data){
				if(data.available == "false")
				{
					layerUtils.iAlert("请检查网络是否正常!",-1,function(){return false;
						shellPlugin.callShellMethod("closeAppPlugin",null,null);
					});
				}
			},null,{});
		},1000);
	}
	
	/* 执行更新操作 */
	function execUpdate(data)
	{
		var updateParam = {
			"url" : data.results[0].update_url,  // 更新地址
			"versionLatest" : data.results[0].version,  // 最新版本号
			"versionLowest" : data.results[0].enforcement == "1" ? data.results[0].enforcement : "0"  // 强制更新最低版本号，只有一条记录时，界限版本传 0 ，表示不需要强制更新
		};
		shellPlugin.callShellMethod("updateManagerPlugin",null,null,updateParam);
	}
	
	function bindPageEvent(){
		//绑定下一步(我知道了)
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			appUtils.pageInit("account/openAccount","account/msgVerify",{});
		}); 	
	}
	
	function destroy(){
	}
	// 对外暴露的模块方法 end
	var openAccount = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	// 暴露对外的接口
	module.exports = openAccount;
});