/**
 * 风险测评
 */
define("project/scripts/account/riskAssessment", function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(), //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		_pageId = "#account_riskAssessment",
		Map = require("map");
	/* 私有业务模块的全局变量 end */

	function init() {
		// 如果是从 短信验证码 或者 三方存管进入本页面，执行初始化操作，否则不执行初始化操作
		fristMap = new Map();
		getRiskAssessQuestions(); //获取问卷答题
		$("#bodyContent").css({"overflow":"visible"});

	}

	function bindPageEvent() {
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId + " .header .icon_back"), function() {
			pageBack();
		});
		/* 提交答题  */
		appUtils.preBindEvent($(document), _pageId + " .ct_btn", function() {
			var keys = fristMap.keys();
			postRiskAssessmentData(keys); //提交答题

		});
	}
	/* 处理返回按钮 */
	function pageBack() {
		
			appUtils.pageInit("account/riskAssessment", "account/thirdDepository", {});
		
	}

	function destroy() {
		service.destroy();
	}

	/* 获取风险测评题库 */
	function getRiskAssessQuestions() {
		var userid = appUtils.getSStorageInfo("user_id");
		var queryTestParam = {
			"user_id": userid
		};
		//查询风险评测
		service.queryRiskToc(queryTestParam, function(data) {
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo == 0 && data.results.length != 0) //调用成功,跳转到风险测评页面
			{
				var results = data.results;
				var questionHtml = "";
				$(_pageId + " .test_main").html("");
				for(var i = 0; i < results.length; i++) //先遍历
				{
					var oneEle = results[i];
					var queid = oneEle.que_id; // que_id	题目编号
					var type = oneEle.type; // type	问题类型（0：单选，1：多选）
					var qname = oneEle.q_name; // q_name	题目描述
					var str = type + "-" + queid + "-" + qname;
					var secondMap = null;
					if(!fristMap.containsKey(str)) //若map中没有对应的问题号，则存入问题号
					{
						secondMap = new Map();
						secondMap.put(oneEle.ans_id, oneEle);
						fristMap.put(str, secondMap); //fristMap每一个Key对应一个问题
					} else {
						fristMap.get(str).put(oneEle.ans_id, oneEle);
					}
				}
				var keys = fristMap.keys();
				for(var j = 0; j < keys.length; j++) {
					var oneData = fristMap.get(keys[j]); // 取出一个问题
					questionHtml += createRiskAccessElement(oneData, keys[j], j + 1);
				}
				$(_pageId + " .test_main").html(questionHtml);
				//当题目过多，则设置下一步按钮悬浮底部
				if($(document.body).height() < $(_pageId).height()) {
					$(_pageId + " .fix_bot").css("position", "fixed");
				} else {
					$(_pageId + " .fix_bot").css("position", "absolute");
				}
				var count=0;
				var questHeight = 0;
				//为选择按钮添加事件
				appUtils.bindEvent($(_pageId + " .test_main .icon_radio"), function() {
					var quetype = $(this).attr("que-type"); //问题类型0：单选，1：多选
					var queid = $(this).attr("id");
					if(quetype == 1) {
						$(this).toggleClass("checked");
					} else {
						if($(this).hasClass("checked")) {
						    hh=$("#"+$(this).parent().parent().attr("id")).offset().top - $(_pageId+" .test_main").offset().top + $(_pageId+" .test_main").scrollTop();
							$(this).parent().parent().prev("h5").css("color", "red"); //未选择答案，则将该题标记为红色
							$(this).removeClass("checked");
						} else {
							//20170322添加题目移动效果
							var count = $(this).parent().parent().attr("id").split("-")[0];
					        var hh=$(_pageId+" .header").height()+$(_pageId+" .top_step").height()+$(_pageId+" .top_title").height()+24;
							for(var i=0;i<count; i++){
								hh += $(_pageId+" .test_box").eq(i).height()+20;
							}
							$(_pageId + " .test_main #" + queid).removeClass("checked");
							$(this).parent().parent().prev("h5").css("color", "#666666"); // 题目红色标记恢复黑色
							$(this).addClass("checked");
						}
						$("body").animate({scrollTop:hh});
					}
				});
				//setDefaultAnswer();  // 设置默认的答案，默认是最低风险承受能力
			} else {
				layerUtils.iMsg("-1", errorInfo);
			}
		}, true, true, handleTimeout);
	}

	/* 处理请求超时 */
	function handleTimeout() {
		layerUtils.iConfirm("请求超时，是否重新加载？", function() {
			getRiskAssessQuestions(); // 再次风险测评题目
		});
	}

	/* 设置问题的默认答案 */
	function setDefaultAnswer() {
		var questionList = $(_pageId + " .test_main .input_list"); // 获取所有问题的集合
		// 处理每一个问题
		questionList.each(function() {
			var markArray = new Array();
			for(var i = 0; i < $(this).children("p").length; i++) {
				markArray.push(Number($(this).children("p").eq(i).children("a").attr("ans-mark")));
			}
			markArray.sort(); // js 的 sort 方法是在原数组的基础上进行排序
			$(this).children("p").children("a[ans-mark='" + markArray[0] + "']").addClass("checked");
		});
	}

	/**
	 * 创建一个问题项目
	 * @param oneData 一个问题结果集
	 * @param key 结构type+"-"+queid+"-"+qname;
	 */
	function createRiskAccessElement(oneData, key, index) {
		var type = key.split("-")[0];
		var queid = key.split("-")[1];
		var qname = key.split("-")[2];
		var oneDatakeys = oneData.keys();
		var itemHtml = "";
		var itemHead = "";
		var itemElem = "";
		var str = "(多选)";
		// 问题标号
		var bgNum = "A";
		for(var i = 0; i < oneDatakeys.length; i++) //先遍历确定有多少题
		{
			var oneElem = oneData.get(oneDatakeys[i]);
			var mark = oneElem.mark; // 答案分值
			var aname = oneElem.a_name; // 答案描述
			var ansid = oneElem.ans_id;
			if(type == 0) str = "(单选)";
			bgNum = changQuestionBgNum(i);
			itemElem += "<p><a href=\"javascript:void(0);\" class=\"icon_radio\" que-type =\"" + type + "\" ans-id=\"" + ansid + "\" ans-mark=\"" + mark + "\" id =\"" + queid + "\">" + bgNum + ". " + aname + "</a></p>";
		}
		itemHead = "<h5>" + index + ". " + qname + str + "</h5>";
		itemHtml = "<div class=\"test_box\">" + itemHead + "<div class=\"input_list\" id=\"" + (index + "-" + queid) + "\">" + itemElem + "</div></div>";
		return itemHtml;
	}

	/* 提交风险评测答案 */
	function postRiskAssessmentData(keys) {
		var oneRiskAssessData = ""; // 格式如：1_2_7|2_7_3|  问题ID_答案ID_答案分值
		var countNoChoice = 0; // 没有选择问题数量
		var numNoChoice = ""; // 没有选择问题题号
		var array = new Map();
		for(var j = 0; j < keys.length; j++) {
			var index = j + 1;
			var queid = keys[j].split("-")[1];
			var isChoice = false;
			$(_pageId + " .test_main #" + queid).each(function() {
				if($(this).hasClass("checked")) {
					isChoice = true;
					var ansid = $(this).attr("ans-id");
					var mark = $(this).attr("ans-mark");
					oneRiskAssessData += (queid + "_" + ansid + "_" + mark + "|");
				}
			});
			if(!isChoice) // 没有选中 则记录未提交的题目编号
			{
				countNoChoice++;
				numNoChoice += index + "、";
			}
		}
		if(countNoChoice > 0) //您的答题尚未完成
		{
			numNoChoice = numNoChoice.substring(0, numNoChoice.length - 1); // 去掉最后一个逗号
			layerUtils.iAlert("您的答题尚未完成，未完成题目编号：" + numNoChoice);
			return false;
		}
		var userid = appUtils.getSStorageInfo("user_id");
		var submitTestParam = {
			"user_id": userid,
			"sub_id": "3",
			"q_a_args": oneRiskAssessData
		};
		//提交风险评测答案
		service.submitTestAnswer(submitTestParam, function(data) {
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if(errorNo == 0 && data.results.length != 0) //调用成功,判断是否调用回访页面
			{
				//	var remark = data.results[0].riskexp;
				//风险测评结果
				var riskresult = {
					"remark": data.results[0].remark,
					"riskdesc": data.results[0].riskdesc,
					"score": data.results[0].score,
					"investment_products":data.results[0].investment_products,
					"investment_term":data.results[0].investment_term,
					"investment_advice":data.results[0].investment_advice,
					"riskexp":data.results[0].riskexp,
					"lowestLevel":data.results[0].lowestLevel
				}

				appUtils.pageInit("account/riskAssessment", "account/riskAssessmentResult", riskresult);

				//回访问卷的开关
				//isNeedConfirm();

			} else {
				layerUtils.iMsg("-1", errorInfo);
			}
		});
	}

	//查询回访问卷配置
	function isNeedConfirm() {
		service.queryDataDict({
			"item_name": "isNeedConfirm"
		}, function(data) {
			if(data.error_no == 0) {
				var confirm = data.results;
				var isNeedConfirm = confirm.length != 0 && confirm[0].item_value ? 　confirm[0].item_value : "1";
				appUtils.setSStorageInfo("isNeedConfirm", isNeedConfirm);
				if(isNeedConfirm == 0) {
					//跳转到会访页面
					appUtils.pageInit("account/riskAssessment", "account/openConfirm");

				} else {
					//先判断是否进行过视频见证，没有见证跳到视频见证页面，见证过就跳到完成开户页面
					queryQQOfflineState();

				}
			} else {
				layerUtils.iLoading(false); // 关闭等待层。。。
				layerUtils.iAlert(data.error_info);
			}
		});

	}

	/* 查询离线视频通过状态 */
	function queryQQOfflineState() {
		var lookVedioStateParam = {
			"user_id": appUtils.getSStorageInfo("user_id")
		};
		service.queryQQOfflineState(lookVedioStateParam, function(data) {
			var error_no = data.error_no;
			var error_info = data.error_info;
			if(error_no == 0 && data.results.length != 0) {
				// 视频通过状态，0：未见证、2：已预约离线见证未完成见证、1：视频见证完成、3：见证失败
				// 未见证不需要做处理
				var witnessFlag = data.results[0].witness_flag;
				if(witnessFlag == 1) {
					layerUtils.iAlert("您的视频见证已通过！", 0);
					//若不需要安装证书，直接跳转到开户完成页面
					appUtils.pageInit("account/riskAssessment", "account/accountResult", {});

				} else {
					//其他值，表示没有通过视频见证，跳到视频见证页面
					appUtils.pageInit("account/riskAssessment", "account/videoNotice", {});
				}
			} else {
				layerUtils.iAlert(data.error_info);
				layerUtils.iLoading(false);
			}
		});
	}

	/*改变问题答案*/
	function changQuestionBgNum(num) {
		var bgNum = "A";
		switch(num) {
			case 0:
				bgNum = "A";
				break;
			case 1:
				bgNum = "B";
				break;
			case 2:
				bgNum = "C";
				break;
			case 3:
				bgNum = "D";
				break;
			case 4:
				bgNum = "E";
				break;
			case 5:
				bgNum = "F";
				break;
			case 6:
				bgNum = "G";
				break;
			default:
				bgNum = "其它";
		}
		return bgNum;
	}

	var riskAssessment = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"pageBack": pageBack,
		"destroy": destroy
	};

	module.exports = riskAssessment;
});