/**
 * 选择营业部
 */
define("project/scripts/account/selDepartment",function(require, exports, module){
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		global = require("gconfig").global,
		layerUtils = require("layerUtils"),
		validatorUtil = require("validatorUtil"),
		provinceList = "",  //省份
		cityList = "",  //城市
		branchList = "",  //营业部
		branchParam={"branchno":""},  //营业部编号
		_pageId = "#account_selDepartment";
	/* 私有业务模块的全局变量 end */

	function init()
	{
	//	$(_pageId+" .header .icon_back").hide(); //隐藏返回按钮
		cleanPageElement(); // 清理页面元素值
		var recommendno = appUtils.getSStorageInfo("recommendno");
		if(recommendno){
			$(".recommendno", _pageId).val(recommendno)
		}
		getBranch();  // 获取营业部
	}

	function bindPageEvent()
	{
		/* 绑定返回 */
		appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
			pageBack();
		});

		/* 点击页面其他元素隐藏下拉列表 */
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+" .sel_list").slideUp("fast",function(){
				$("#bodyContent").css("overflow","auto");
			});	// 隐藏下拉列表
			e.stopPropagation();	// 阻止冒泡
		});

		/* 绑定选择省份 */
		appUtils.bindEvent($(_pageId+" .mobile_form .sel_province"),function(e){
			$(_pageId+" .city").hide();  //隐藏城市列表
			$(_pageId+" .branch").hide();  //隐藏营业部列表
			$(_pageId+" .province ul li").removeClass("active");
			$(_pageId+" .province").slideToggle("fast",function(){
				$("#bodyContent").css("overflow","hidden");
			});	 // 显示选择省份的下拉列表
			e.stopPropagation();	// 阻止冒泡
		});

		/* 绑定选择城市 */
		appUtils.bindEvent($(_pageId+" .mobile_form .sel_city"),function(e){
			$(_pageId+" .province").hide();  //隐藏省份列表
			$(_pageId+" .branch").hide();  //隐藏营业部列表
			$(_pageId+" .city ul li").removeClass("active");
			$(_pageId+" .city").slideToggle("fast",function(){
				$("#bodyContent").css("overflow","hidden");
			});	// 显示选择城市的下拉列表
			e.stopPropagation();	// 阻止冒泡
		});

		/* 绑定选择营业部 */
		appUtils.bindEvent($(_pageId+" .mobile_form .sel_branch"),function(e){
			$(_pageId+" .province").hide();  //隐藏省份列表
			$(_pageId+" .city").hide();  //隐藏城市列表
			$(_pageId+" .branch ul li").removeClass("active");
			$(_pageId+" .branch").slideToggle("fast",function(){
				$("#bodyContent").css("overflow","hidden");
			});	// 显示选择营业厅的下拉列表
			e.stopPropagation();	// 阻止冒泡
		});

		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			var branch_name = $(_pageId+" .mobile_form .sel_branch").text();
			var province_name = $(_pageId+" .mobile_form .sel_province").text();
			var city_name = $(_pageId+" .mobile_form .sel_city").text();
			var recommendno = $(".recommendno", _pageId).val().trim();
			appUtils.setSStorageInfo("branchno",branchParam.branchno);  //营业部id保存在session
            // 保存经纪人信息
            appUtils.setSStorageInfo("recommendno", recommendno);
			if(province_name == "请选择省份")
			{
				layerUtils.iMsg(-1,"请选择开户省份");
				return false;
			}
			else if(city_name == "请选择城市")
			{
				layerUtils.iMsg(-1,"请选择开户城市");
				return false;
			}
			else if(branch_name == "请选择营业部")
			{
				layerUtils.iMsg(-1,"请选择开户营业部");
				return false;
			}
			else if(recommendno !== "" && !validatorUtil.isNumeric(recommendno)){
				layerUtils.iMsg(-1,"营销人员代码必须为数字");
				return false;
			}
			if(recommendno !== "" && !(recommendno.length == 6 || recommendno.length == 8)){
				layerUtils.iMsg(-1,"营销人员代码必须为6位或8位数字");
				return false;
			}
			appUtils.pageInit("account/selDepartment","account/uploadPhoto",branchParam);
			appUtils.clearSStorage("idInfo");  // 清除完成身份证上传步骤标记
		});
	}
	
    /* 处理返回按钮 */
	function pageBack()
	{
		appUtils.pageInit("account/selDepartment","account/msgVerify",{});
			
	}
	
	function destroy()
	{
		service.destroy();
	}

	/* 获取营业部 */
	function getBranch()
	{
		var channel_branchno =appUtils.getSStorageInfo("channel_branchno");
		//获取营业部
		var param ={
			"branchno" : channel_branchno
		};
		service.queryBranch(param,function(data){
			var error_no = data.error_no,
				error_info = data.error_info;
			if(error_no=="0" && data.dsName)
			{

				provinceList = data.provinceList; //省份集合
				cityList = data.cityList;	//城市集合
				branchList = data.branchList;	//营业部集合
				var plen = provinceList.length,
					clen = cityList.length,
					blen = branchList.length;
				var pro_str = "";
				if(plen==1){
					for(var i=0; i<plen; i++)
					{
						var provinceno = provinceList[i].provinceno; //省份id
						var provincename = provinceList[i].provincename;  //省份名称
						var cityno = cityList[i].cityno;
						var cityname = cityList[i].cityname;
						var branchcode = branchList[i].branchcode;
						var branchname = branchList[i].branchname;

						branchParam.branchno = branchcode;
						$(_pageId+" .sel_province").text(provincename);
						$(_pageId+" .sel_city").text(cityname);
						$(_pageId+" .sel_branch").text(branchname);
					}
				}else{
					for(var i=0; i<plen; i++)
					{
						var provinceno = provinceList[i].provinceno; //省份id
						var provincename = provinceList[i].provincename;  //省份名称

						pro_str+= "<li pid='"+provinceno+"'><span>"+provincename+"</span></li>";
					}
					$(_pageId+" .province ul").html(pro_str);  //填充省份下拉框
					bindProvince();  //点击省份
				}

			}
			else
			{
				layerUtils.iMsg(-1,"营业部获取失败");  //提示错误信息
			}
		},true,true,handleTimeout);
	}

	/* 处理请求超时 */
	function handleTimeout()
	{
		layerUtils.iConfirm("请求超时，是否重新加载？",function(){
			getBranch();  // 再次获取营业部
		});
	}

	/* 选中省份事件处理 */
	function bindProvince()
	{
		appUtils.bindEvent($(_pageId+" .province ul li"),function(e){
			var pid = $(this).attr("pid");
			$(this).addClass("active").siblings().removeClass("active");
			var provincename = $(this).text();  //当前选中省份的值
			var sel_pname = $(_pageId+" .sel_province").text();  //上一次选中省份的值
			$(_pageId+" .sel_province").text(provincename);	  //将选中值赋给选择框
			$(_pageId+" .province").slideUp("fast",function(){
				$("body #bodyContent").css("overflow","auto");
			});	//隐藏下拉框
			//再次点击相同省份,下级菜单不改变，否则重置
			if(provincename != sel_pname)
			{
				$(_pageId+" .sel_city").text("请选择城市");
				$(_pageId+" .sel_branch").text("请选择营业部");
				$(_pageId+" .branch ul").html("");
			}
			var provincenno = "";  //省份ID
			var cityno = "";
			var cityname = "";
			var city_str = "";
			//选中省份立即填充相应城市
			for(var i=0; i<cityList.length; i++)
			{
				provincenno = cityList[i].provincenno;
				cityno = cityList[i].cityno;
				cityname = cityList[i].cityname;
				if(pid == provincenno)  //填充当前省份下的城市列表
				{
					city_str+= "<li cid='"+cityno+"'><span>"+cityname+"</span></li>";
				}
			}
			$(_pageId+" .city ul").html(city_str);  //填充城市下拉框
			e.stopPropagation();	// 阻止冒泡
			bindCity();  //点击城市
		});
	}

	/* 选中城市事件绑定 */
	function bindCity()
	{
		appUtils.bindEvent($(_pageId+" .city ul li"),function(e){
			var cid = $(this).attr("cid");
			$(this).addClass("active").siblings().removeClass("active");
			var cityname = $(this).text();  //当前选择城市的值
			var sel_cname = $(_pageId+" .sel_city").text();  //上次选择城市的值
			$(_pageId+" .sel_city").text(cityname);	  //选中值赋给选择框
			$(_pageId+" .city").slideUp("fast",function(){
				$("body #bodyContent").css("overflow","auto");
			});	//隐藏下拉框
			//再次点击相同城市,下级菜单不改变，否则重置
			if(sel_cname != cityname)
			{
				$(_pageId+" .sel_branch").text("请选择营业部");
			}
			//选中城市立即填充相应营业部
			var cityno = "",branchcode,branchname;  //城市ID
			var branch_str = "";
			for(var i=0; i<branchList.length; i++)
			{
				cityno = branchList[i].cityno;
				branchcode = branchList[i].branchcode;
				branchname = branchList[i].branchname;
				if(cid == cityno)  //填充当前城市下的营业部列表
				{
					branch_str+= "<li bid='"+branchcode+"'><span>"+branchname+"</span></li>";
				}
			}
			$(_pageId+" .branch ul").html(branch_str);  //填充营业部下拉框
			e.stopPropagation();	// 阻止冒泡
			bindBranch();  //点击营业部
		});
	}

	/* 选中营业部事件绑定*/
	function bindBranch()
	{
		appUtils.bindEvent($(_pageId+" .branch ul li"),function(e){
			var bid = $(this).attr("bid");
			$(this).addClass("active").siblings().removeClass("active");
			branchParam.branchno = bid;
			var branchname = $(this).text();  //当前选中营业部的值
			var sel_bname = $(_pageId+" .sel_branch").text();  //上一次选中营业部的值
			$(_pageId+" .sel_branch").attr("branchcode",bid);
			$(_pageId+" .sel_branch").text(branchname);	  //选中值赋给选择框
			$(_pageId+" .branch").slideUp("fast",function(){
				$("body #bodyContent").css("overflow","auto");
			});	//隐藏下拉框
			e.stopPropagation();	// 阻止冒泡
		});
	}

	/* 清理界面元素 */
	function cleanPageElement()
	{
		$(_pageId+" .sel_province").text("请选择省份");
		$(_pageId+" .sel_city").text("请选择城市");
		$(_pageId+" .sel_branch").text("请选择营业部");
	}

	var selDepartment = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"pageBack" : pageBack,
		"destroy" : destroy
	};

	// 暴露对外的接口
	module.exports = selDepartment;
});