/**
 * 设置证书密码
 */
define("project/scripts/account/setPwdCertificate",function(require, exports, module){ 
	// 私有业务模块的全局变量 begin
	service = require("serviceImp").getInstance(),  //业务层接口，请求数据
			global = require("gconfig").global,
			appUtils = require("appUtils"),
			layerUtils = require("layerUtils"),
			validatorUtil = require("validatorUtil"),
			psw_id = "",  // 选择密码框的id
			cert_type = "zd",
			_pageId = "#account_setPwdCertificate";
	// 私有业务模块的全局变量 end
	
	function init()
	{
		window.getInput = getInput;  // 输入密码，获取密码值
		window.onFinish = onFinish;  // 完成输入密码
		subIdCard();
	}
	
	//默认选中勾选证书密码为身份证后六位
	function subIdCard()
	{
		var idNo=appUtils.getSStorageInfo("idCardNo");
		var idLength=idNo.length;
		var idcard="";
		if(idNo){
			if(idLength==15)
			{
				idcard=idNo.substr(idNo.length-6);
				$(_pageId+" .cert_code .pwd1").val(idcard);
				$(_pageId+" .cert_code .pwd2").val(idcard);
				//将数字证书密码保存在session中
				appUtils.setSStorageInfo("numbercertPwd",idcard);
			}
			else if(idLength==18)
			{
				idcard=idNo.substr(idNo.length-6);
				$(_pageId+" .cert_code .pwd1").val(idcard);
				$(_pageId+" .cert_code .pwd2").val(idcard);
				appUtils.setSStorageInfo("numbercertPwd",idcard);				
			}
		}
	}	
				
	/* 获取密码值*/
	function getInput(data)
	{
		$(_pageId+" "+psw_id).val(data);
	}
		
	/* 关闭密码键盘 */
	function onFinish()
	{
		$("body").css("padding-bottom","0").scrollTop(0);
	}
		
		/*自定义返回按钮*/
	/*function pageBack()
	{
		if(appUtils.getSStorageInfo("_prePageCode") == "account/msgVerify.js")
		{
			// 新开跳uploadPhoto，转户跳uploadPhotoChange
			if(appUtils.getSStorageInfo("openChannel") == "new")
			{
				appUtils.pageInit("account/setPwdCertificate","account/msgVerify",{});
			}
			else if(appUtils.getSStorageInfo("openChannel") == "change")
			{
				appUtils.pageInit("account/setPwdCertificate","account/msgVerify",{});
			}
		}
		else
		{
			appUtils.pageBack();
		}
	}*/
		
	function bindPageEvent()
	{
		/* 点击页面隐藏键盘 */
		appUtils.bindEvent($(_pageId),function(e){
			//关闭密码键盘
			require("shellPlugin").callShellMethod("softKeyboardPlugin",null,null,{"isShow":false});
			onFinish();
			e.stopPropagation();	// 阻止冒泡
		});
		 
		/* 点击证书密码框统一调用密码键盘 */
		appUtils.bindEvent($(_pageId+" .cert_code input"),function(e){
			psw_id = "#"+$(this).attr("id"); //当前input元素id
			var pwsdParam = {"isShow":true,"oldPwd":$(this).val(),"maxLength":6};
			var topHeight = $(this).offset().top+$(this).parent().height();  //当前元素到顶部的高度
			var bodyHeight = $(document.body).height();  //当前body的高度
			require("shellPlugin").callShellMethod("softKeyboardPlugin",function(data){
				//解决弹出键盘遮挡输入框的情况
				var keyheight = data.height/window.devicePixelRatio; //键盘高度
				var newbody = bodyHeight - keyheight; // 键盘弹出 body的高度
				var scrollheight = topHeight - newbody; // 输入框被遮住的高度
				if(scrollheight>0) //只有当密码键盘挡住输入框的时候才进行处理
				{
					scrollheight2 = bodyHeight - $(_pageId).height() + scrollheight; //页面需要滚动的高度
					$("body").css("padding-bottom",scrollheight2+"px").scrollTop(scrollheight);
				}
			},null,pwsdParam);
			e.stopPropagation();	// 阻止冒泡
		});

		/* 绑定返回 
		appUtils.bindEvent($(_pageId+" .header .icon_close"),function(){
			pageBack();
		});*/
		
		//显示关于数字证书的说明
		appUtils.bindEvent($(_pageId+" .cert_code p a"),function(e){
			$(_pageId+" .fix_info").slideDown("fast");
			e.stopPropagation();
		});
		
		//隐藏关于数字证书的说明
		appUtils.bindEvent($(_pageId),function(e){
			$(_pageId+" .fix_info").slideUp("fast");
		});
		
		/* 绑定下一步 */
		appUtils.bindEvent($(_pageId+" .fix_bot .ct_btn"),function(){
			postData();
		});
	}
	/***
	 * 提交用户数据到下一步
	 */
	function postData(){
		var pwd1 = $(_pageId+" .cert_code input:eq(0)").val(),
			  pwd2 = $(_pageId+" .cert_code input:eq(1)").val();
		if(validatorUtil.isEmpty(pwd1)||pwd1.length!=6)
		{
			layerUtils.iAlert("证书密码必须为六位数字");
			return false;
		}
		else if(pwd1!=pwd2)
		{
			layerUtils.iAlert("确认密码与证书密码不一致");
			$(_pageId+" .cert_code input:eq(1)").val("");
			return false;
		}
		appUtils.pageInit("account/setPwdCertificate","account/digitalCertificate",
				{"certificatePwd":$(_pageId+" .cert_code input:eq(0)").val()});
	}
	function destroy()
	{
		//清除密码
		$(_pageId+" .cert_code input").val("");
	}
	// 对外暴露的模块方法 end
	
	var showDigitalProtocol = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	// 暴露对外的接口
	module.exports = showDigitalProtocol;
});