/**
 * 三方存管
 */
define("project/scripts/account/thirdDepository", function(require, exports, module) {
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		global = require("gconfig").global,
		service = require("serviceImp").getInstance(), // 业务层接口，请求数据
		layerUtils = require("layerUtils"),
		utils = require("utils"),
		validatorUtil = require("validatorUtil"),
		platform = require("gconfig").platform,
		zzispwd = "", // zzispwd	密码方式，1 需要密码，0 不需要
		zzbindtype = "",
		cur_value,
		protocol = null, // 协议保存
		cert_type = appUtils.getSStorageInfo("openChannel") == "new" ? "zd" : "tw", // tw:天威 zd:中登
		_pageId = "#account_thirdDepository";
	/* 私有业务模块的全局变量 end */

	function init() {
		$(_pageId + " .user_form .input_form:eq(1) .input_text:eq(0)").show(); // 显示银行卡
		$(_pageId + " #bankcardPwd").parent().show(); // 显示银行密码输入框
		$(_pageId + " .protocolshow").hide();
		window.getInput = getInput; // 输入密码，获取密码值 
		window.onFinish = onFinish; // 完成输入密码
		protocol = null; // 协议
		if (platform == '2' || platform == '3') {
			$(_pageId + " #bankcardPwd").removeAttr("readonly");
		}
		// 开启等待层。。。
		layerUtils.iLoading(true);
		/* 获取存管银行列表 */
	    getBankList();
		//检测是否需要证书
//		$(function(){
//			cur_value = appUtils.getSStorageInfo("cur_value");
//			if(!cur_value){
//				service.needCertificate(null, function(data){
//					if(data.error_no === "0"){
//						cur_value = data.results[0].cur_value;
//						continuePageBusiness();
//					}else{
//						layerUtils.iAlert(data.error_info,-1);
//						layerUtils.iLoading(false);
//					}
//				});
//			}else{
//				continuePageBusiness();
//			}
//
//			function installCertificate(){
//				var existsParam = {
//					"userId": appUtils.getSStorageInfo("user_id"),
//					"mediaid": "certificate",
//					"type": cert_type
//				};
//				require("shellPlugin").callShellMethod("fileIsExistsPlugin", function(data) {
//					// 如果未检测到本地有证书，就安装证书
//					if (data.mediaId == "") {
//						utils.installCertificate(getBankList); //下载安装证书并且获取银行列表
//					} else {
//						getBankList(); //获取银行列表
//					}
//				}, function() {
//					// 关闭等待层。。。
//					layerUtils.iLoading(false);
//				}, existsParam);
//			}
//
//			function continuePageBusiness(){
//				//若为0，表示不需要安装证书
//				if(cur_value === "0"){
//					getBankList();
//				}else{
//					installCertificate();
//				}
//			}
//		});
	}

	function bindPageEvent() {
	 /* 绑定返回 */
        appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
            pageBack();
        });
	
	
		/* 点击页面隐藏键盘 */
		appUtils.bindEvent($(_pageId), function(e) {
			$(_pageId + " #bankListPage").slideUp("fast"); // 隐藏银行卡列表
			if (platform == '1') {
				require("shellPlugin").callShellMethod("softKeyboardPlugin", null, null, {
					"isShow": false
				}); //关闭密码键盘
				onFinish();
			}
			e.stopPropagation(); // 阻止冒泡
		});

		/* 签署银行相关协议  */
		appUtils.bindEvent($(_pageId + " .rule_check a"), function() {
			$(this).toggleClass("checked");
		});

		/* 选择银行绑定下拉框按钮事件  */
		appUtils.bindEvent($(_pageId + " #selectBank"), function(e) {
			if (platform == '1') {
				require("shellPlugin").callShellMethod("softKeyboardPlugin", null, null, {
					"isShow": false
				}); //关闭密码键盘
			}
			$(_pageId + " #bankListPage ul li").removeClass("active");
			$(_pageId + " #bankListPage").slideDown("fast"); // 显示银行下拉列表
			e.stopPropagation(); // 阻止冒泡
		});

		/* 选择银行卡绑定选择某银行事件 */
		appUtils.bindEvent($(_pageId + " #bankcard"), function(e) {
			validateSelectBank(); // 验证是否选择银行卡
			if (platform == '1') {
				require("shellPlugin").callShellMethod("softKeyboardPlugin", null, null, {
					"isShow": false
				}); //关闭密码键盘
			}
			e.stopPropagation(); // 阻止冒泡
		});

		/* 银行卡号输入控制（每四位分隔） */
		appUtils.bindEvent($(_pageId + " #bankcard"), function() {
			utils.dealIPhoneMaxLength(this, 19); // 最大输入长度
			utils.showBigNo(this, 2); // 调用放大镜插件
		}, "input");

		/* 银行密码输入框 */
	/*	appUtils.bindEvent($(_pageId + " #bankcardPwd"), function(e) {
			validateSelectBank(); // 验证是否选择银行卡
			if (platform == '1') {
				var topHeight = $(this).offset().top + $(this).parent().height(); // 当前元素到顶部的高度
				var bodyHeight = $(document.body).height(); // 当前body的高度
				var pwsdParam = {
					"isShow": true,
					"oldPwd": $(this).val(),
					"maxLength": 6
				};
				require("shellPlugin").callShellMethod("softKeyboardPlugin", function(data) {
					// 解决弹出键盘遮挡输入框的情况
					var keyheight = data.height / window.devicePixelRatio; // 键盘高度
					var newbody = bodyHeight - keyheight; // 键盘弹出 body的高度
					var scrollheight = topHeight - newbody; // 输入框被遮住的高度
					if (scrollheight > 0) // 只有当密码键盘挡住输入框的时候才进行处理
					{
						scrollheight2 = bodyHeight - $(_pageId).height() + scrollheight; //页面需要滚动的高度
						$("body").css("padding-bottom", scrollheight2 + "px").scrollTop(scrollheight);
					}
				}, null, pwsdParam);
			}
			e.stopPropagation(); // 阻止冒泡
		});*/

		/* 开通三方存管按钮绑定事件 */
		appUtils.bindEvent($(_pageId + " .ct_btn"), function() {
			if(validatePage()){
//				if(cur_value === "0"){
					signProtocol_no();
//				}else{
//					signProtocol(); // 提交验签，并且提交三方存管信息
//				}
			}
		});
	}
    
    /* 处理返回按钮 */
	function pageBack() {
		cleanPageElement();
		appUtils.pageInit("account/thirdDepository", "account/setPwd", {});	
	}

	function destroy() {
		service.destroy();
	}

	/* 获取存管银行列表 */
	function getBankList() {
		var queryParam = {
				"zzbindtype": "",
				"zzispwd": ""
			};
			// 调用service查询存管银行list
		service.queryBankList(queryParam, function(data) {
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			// 清除页面的银行列表
			$(_pageId + " .sel_list ul").html("");
			if (errorNo == 0 && data.results.length != 0) // 调用成功
			{
				var results = data.results;
				var length = results.length;
				var itemElement = "";
				var pwd_infoElement = "";
				for (var i = 0; i < length; i++) {
					var item = results[i];
					// 银行代码
					var bankcode = item.bankcode;
					var bankname = item.bankname;
					var sortnum = item.sortnum;
					var smallimg = item.smallimg;
					var isbuffet = item.isbuffet;
					// 银行的签约信息（一卡多签、一卡一签）
					var signInfo = item.sign_info;
					// zzbindtype	绑定方式，1 一步式，2 预指定
					zzbindtype = item.zzbindtype;
					var pwd_info = item.pwd_info;
					itemElement += "<li><span bankname='" + bankname + "' id='" + bankcode + "' " +
						"zzispwd=\"" + item.zzispwd + "\"" +
						"zzbindtype=\"" + zzbindtype + "\" sign-info=\"" + signInfo + "\"+" +
						"style=\"display:none;\" data-pwd_info=\"" + pwd_info + "\">" + bankname + "</span>" +
						"</li>";

				}
				$(_pageId + " .sel_list ul").html(itemElement);
				$(_pageId + " .pwd_info").html("");
				// 选择银行添加银行事件
				appUtils.bindEvent($(_pageId + " #bankListPage ul li span"), function(e) {
					$(_pageId + " #bankListPage ul li").removeClass("active");
					$(this).parent().addClass("active");
					$(_pageId + " .protocolshow").show();
					var banckName = $(this).attr("bankname");
					var id = $(this).attr("id");
					// zzispwd	密码方式，1 需要密码，0 不需要
					zzispwd = $(this).attr("zzispwd");
					signInfo = $(this).attr("sign-info");
					zzbindtype = $(this).attr("zzbindtype");
					pwd_info = $(this).attr("data-pwd_info");
					$(_pageId + " .pwd_info").html(pwd_info);
					addBankItem(banckName, id, zzbindtype, signInfo);
					e.stopPropagation();
				});
			} else {
				layerUtils.iAlert(errorInfo, -1);
			}
		}, true, true, handleTimeout);
	}

	/* 处理请求超时 */
	function handleTimeout() {
		layerUtils.iConfirm("请求超时，是否重新加载？", function() {
			getBankList(); // 再次获取银行列表
		});
	}

	/* 为选择银行列表添加选中银行数据 */
	function addBankItem(banckName, id, zzbindtype, signInfo) {
		// 显示银行的签约信息
        console.log("1");
		if (signInfo != "" && signInfo != undefined) {
			$(_pageId + " #signInfo").html("温馨提示: " + signInfo);
		} else // 为空，将原有的提示信息置空
		{
			$(_pageId + " #signInfo").html("");
		}
		$(_pageId + " #bankcard").val(""); // 清空银行卡号值
		$(_pageId + " #bankcardPwd").val(""); // 清空银行卡密码
		$(_pageId + " #selectBank").html(banckName); // 赋值银行卡名称
		$(_pageId + " #selectBank").attr("bankcode", id);
		$(_pageId + " #selectBank").attr("zzbindtype", zzbindtype);
		// 获取银行协议内容
		getDepositoryAgreement(id);
		// zzispwd	密码方式，1 需要密码，0 不需要
		if (zzbindtype == 1) // 判断一步式
		{
			if (zzispwd == 0) // 不需要输入密码
			{
				$(_pageId + " #bankcardPwd").parent().hide(); // 隐藏银行密码输入框
			} else // 需要输入密码
			{
				$(_pageId + " #bankcardPwd").parent().show(); // 显示银行密码输入框
			}
			$(_pageId + " .user_form .input_form:eq(1) .input_text:eq(0)").show(); // 显示银行卡
			$(_pageId + " #bindInfo").hide(); // 隐藏预指定提示信息
		}
		// zzbindtype	绑定方式，1 一步式，2 预指定
		if (zzbindtype == 2) // 判断预指定(二步式)
		{
			$(_pageId + " .user_form .input_form:eq(1) .input_text").hide(); // 隐藏银行卡、密码输入框
			$(_pageId + " #bindInfo").hide(); // 隐藏预指定提示信息
		}
		$(_pageId + " #bankListPage").slideUp("fast"); // 隐藏银行下拉列表
	}

	/* 签署协议 */
	function signProtocol() {
		// 进行协议签署
		var protocolArray = new Array(), // 协议数组
			userid = appUtils.getSStorageInfo("user_id"),
			ipaddr = appUtils.getSStorageInfo("ip"),
			macaddr = appUtils.getSStorageInfo("mac"),
			protocolid = protocol.econtract_no,
			protocolname = protocol.econtract_name,
			summary = protocol.econtract_md5, // 协议内容MD5,签名摘要信息
			signParam = {
				"medid": protocolid,
				"content": summary,
				"userId": userid,
				"type": cert_type
			};
		// 开启等待层。。。
		layerUtils.iLoading(true);
		// 获取协议的数字签名值
		require("shellPlugin").callShellMethod("signPlugin", function(data) {
			// 数字签名值
			var protocoldcsign = data.ciphertext;
			// 添加值到数组中
			var protocol = {
				"protocol_id": protocolid,
				"protocol_dcsign": protocoldcsign,
				"summary": summary
			};
			protocolArray.push(protocol);
			// 签署协议
			var signProtocolParam = {
				"user_id": userid,
				"jsondata": JSON.stringify(protocolArray),
				"ipaddr": ipaddr,
				"macaddr": macaddr
			};
			// 新开中登验签
			if (appUtils.getSStorageInfo("openChannel") == "new") {
				service.queryOpenCheckSign(signProtocolParam, postThirdDepositoryData);
			}
			// 转户天威验签
			else if (appUtils.getSStorageInfo("openChannel") == "change") {
				service.queryOpenCheckTsign(signProtocolParam, postThirdDepositoryData);
			}
		}, function() {
			layerUtils.iLoading(false);
		}, signParam);
	}

	function signProtocol_no(){
		var protocolArray = new Array(), // 协议数组
			userid = appUtils.getSStorageInfo("user_id"),
			ipaddr = appUtils.getSStorageInfo("ip"),
			macaddr = appUtils.getSStorageInfo("mac"),
			protocolid = protocol.econtract_no,
			protocolname = protocol.econtract_name,
			summary = protocol.econtract_md5; // 协议内容MD5,签名摘要信息
		var protocollist = {
			"protocol_id": protocolid,
			"protocol_dcsign": "",
			"summary": summary
		};
		protocolArray.push(protocollist);
		// 签署协议
		var signProtocolParam = {
			"user_id": userid,
			"jsondata": JSON.stringify(protocolArray),
			"ipaddr": ipaddr,
			"macaddr": macaddr,
            "checksign" : "0"
		};
		// 新开中登验签
		if (appUtils.getSStorageInfo("openChannel") == "new") {
			service.queryOpenCheckSign(signProtocolParam, postThirdDepositoryData);
		}
		// 转户天威验签
		else if (appUtils.getSStorageInfo("openChannel") == "change") {
			service.queryOpenCheckTsign(signProtocolParam, postThirdDepositoryData);
		}
	}


	/* 提交三方存管银行数据 */
	function postThirdDepositoryData() {
		var userid = appUtils.getSStorageInfo("user_id");
		var bankcode = $(_pageId + " #selectBank").attr("bankcode");
		var bankaccount = $(_pageId + " #bankcard").val();
		var bankpwd = $(_pageId + " #bankcardPwd").val();
		var thirdDepositParam = {
			"user_id": userid,
			"acct_clientid": "",
			"acct_fndacct": "",
			"bank_code": bankcode,
			"bank_account": bankaccount,
			"bank_pwd": bankpwd,
			"op_type": $(_pageId + " #selectBank").attr("zzbindtype")
		};
		// 调用service绑定存管银行
		service.bindBank(thirdDepositParam, function(data) {
			var errorNo = data.error_no;
			var errorInfo = data.error_info;
			if (errorNo == 0) // 调用成功,跳转到风险测评页面
			{
				cleanPageElement();
				appUtils.pageInit("account/thirdDepository", "account/riskAssessment", {});
			} else {
				layerUtils.iLoading(false);
				layerUtils.iAlert(errorInfo, -1);
			}
		}, false);
	}

	function validatePage(){
		// 验证是否选择银行
		if (!validateSelectBank()) {
			return false;
		}
		if (zzbindtype == 1 && !validateBankCorrect()) // 验证银行卡号
		{
			return false;
		}
		if (zzbindtype == 1 && zzispwd == 1) // 验证是否需要密码
		{
			if (!validateBankPwd()) {
				return false;
			}
		}
		// 验证是否勾选协议
		if (!validateDepositProtocolSelect()) {
			return false;
		}

		return true;
	}

	/* 验证是否选择银行  */
	function validateSelectBank() {
		var obj = $(_pageId + " #selectBank");
		var value = obj.html();
		if (validatorUtil.isEmpty(value) || value == "请选择银行") {
			layerUtils.iMsg(-1, "请选择银行");
			return false;
		}
		return true;
	}

	/* 检验银行卡填写是否正确 */
	function validateBankCorrect() {
		var bankcard = $(_pageId + " #bankcard").val();
		if (bankcard == "") // 验证通过的情况
		{
			layerUtils.iMsg(-1, "银行卡号不能为空！");
			return false;
		}
		if (!validatorUtil.isBankCode(bankcard)) {
			layerUtils.iMsg(-1, "银行卡号格式有误，请重新输入！");
			return false;
		}
		if(bankcard.length<16||bankcard.length>19){
            layerUtils.iMsg(-1, "银行卡号格式有误，请重新输入！");
			return false;
        }
		return true;
	}

	/* 验证银行密码 */
	function validateBankPwd() {
		// 验证不通过
		var cardPwd = $(_pageId + " #bankcardPwd").val();
		if(cardPwd == ""){
			layerUtils.iMsg(-1, "请输入银行卡密码！");
			return false;
		}
		
		if (!validatorUtil.isNumeric(cardPwd) || cardPwd.length != 6) {
			layerUtils.iMsg(-1, "银行卡密码有误，请重新输入！");
			return false;
		}
		return true;
	}

	/* 检测勾选阅读协议 */
	function validateDepositProtocolSelect() {
		if (!$(_pageId + " .icon_check").hasClass("checked")) {
			layerUtils.iMsg(-1, "请阅读并勾选三方存管协议!");
			return false;
		}
		return true;
	}

	/* 获取存管银行签约电子协议列表 */
	function getDepositoryAgreement(bankcode) {
		// 获取银行协议的参数
		var param = {
			"econtract_no": bankcode
		};
		// 调用service查询存管银行协议
		service.queryProtocolList(param, function(data) {
			$(_pageId + " #protocolName").html("");
			if (data.error_no == 0) {
				if (data.results && data.results.length >= 1) {
					protocol = data.results[0];
                    console.log(protocol);
					$(_pageId + " #protocolName").html("《" + protocol.econtract_name + "》");
					$(_pageId + " #protocolName").attr("protocolId", protocol.econtract_no);
					$(_pageId + " #protocolName").attr("protocolMd5", protocol.econtract_md5);
					// 预绑定查看银行协议内容的事件
					appUtils.preBindEvent($(_pageId + " #protocolName").parent(), "#protocolName", function() {
						appUtils.pageInit("account/thirdDepository", "account/showProtocol", {
							"protocol_id": $(_pageId + " #protocolName").attr("protocolId")
						});
					});
				}
			} else {
				layerUtils.iAlert(data.error_info, -1);
			}
		});
	}

	/* 清理界面元素 */
	function cleanPageElement() {
		$(_pageId + " .rule_check a").removeClass("checked"); // 取消勾选协议
		$(_pageId + " #selectBank").text("请选择银行"); // 清理银行卡的名字
		$(_pageId + " #bankcard").val(""); // 清理银行卡号
		$(_pageId + " #bankcardPwd").val(""); // 清理密码
		$(_pageId + " #protocolName").text("《券商银行投资者三方协议》"); // 清理协议名
		$(_pageId + " #signInfo").html(""); // 清除银行签约信息
	}

	/* 获取密码值*/
	function getInput(data) {
		$(_pageId + " #bankcardPwd").val(data);
	}

	/* 关闭密码键盘 */
	function onFinish() {
		$("body").css("padding-bottom", "0").scrollTop(0);
	}

	var thirdDepository = {
		"init": init,
		"bindPageEvent": bindPageEvent,
		"pageBack" : pageBack,
		"destroy": destroy
	};

	// 暴露对外的接口
	module.exports = thirdDepository;
});