/**
 * 视频见证注意事项
 */
define("project/scripts/account/videoNotice",function(require, exports, module){
    /* 私有业务模块的全局变量 begin */
    var appUtils = require("appUtils"),
        service = require("serviceImp").getInstance(),  //业务层接口，请求数据
        gconfig = require("gconfig"),
	    global = gconfig.global,
        layerUtils = require("layerUtils"),
        cur_value,
        needVideo = "",
    _pageId = "#account_videoNotice";
    /* 私有业务模块的全局变量 end */

    function init()
    {
      
        window.videoSuccess = videoSuccess;
        window.videoFail = videoFail;
        window.videoReject = videoReject;
        initPage();  // 初始化页面
    }

    function bindPageEvent()
    {
        /* 绑定返回 */
        appUtils.bindEvent($(_pageId+" .header .icon_back"),function(){
            pageBack();
        });

        /* 在线视频见证 */
        appUtils.bindEvent($(_pageId+" .ct_btn"),function(){
         	service.getBlackList({"userid":appUtils.getSStorageInfo("user_id")}, function(data1) {
	    	if(data1.error_no == 0){
	    		var result = data1.results;
	    		if(result[0].is_blacklist != "1"){
        			 service.videoTime({"user_id": appUtils.getSStorageInfo("user_id")}, function(results){
           
            if(results.error_no === "0"){
          		    //视频见证请求
					require("shellPlugin").callShellMethod("getNetworkStatusPlugin",function(data){
					
						if(data.netWorkStatus == "2G"){
							appUtils.setSStorageInfo("netWorkStatus","2G");
						}
						if(data.netWorkStatus == "3G"){
							appUtils.setSStorageInfo("netWorkStatus","3G");
						}
						if(data.netWorkStatus == "4G"){
							appUtils.setSStorageInfo("netWorkStatus","4G");
						}
						if(data.netWorkStatus == "WIFI"){
							appUtils.setSStorageInfo("netWorkStatus","WIFI");
						}
						// 如果网络是2G，给出提示
						if(data.netWorkStatus == "2G" || data.netWorkStatus == "NONE")
						{
							layerUtils.iAlert("你当前使用的网络网速较慢，请在3G,4G或者wifi等网路状态下进行视频见证",-1,function(){
								//申请anychat视频见证
								anychatVideoApply();
							});
						}else{
							//申请anychat视频见证
							anychatVideoApply();
						}
					},function(){
						layerUtils.iLoading(false);  // 关闭等待层。。。
					});
            }else{
                layerUtils.iLoading(false);
                layerUtils.iAlert(results.error_info, -1);
            }
         },true,false);
	    		}else{
	    			layerUtils.iAlert("依据适当性管理规定，暂不支持开户!", -1);
	    		}
	    	}else{
	    		layerUtils.iLoading(false);
				layerUtils.iAlert(data1.error_info, -1);
	    	}
	    });
          
         
        });
         
    }
    
    
	//调用anychat视频见证
	function anychatVideoApply(){
		//判断URL是否为空
		var param = {
			"url":global.serverPath+"?",
            "user_id":appUtils.getSStorageInfo("user_id"),
            "user_name":appUtils.getSStorageInfo("custname"),
            "org_id":"01" + appUtils.getSStorageInfo("branchno"),
            "jsessionid":appUtils.getSStorageInfo("jsessionid"),
            "user_type":"1"
        };
		require("shellPlugin").callShellMethod("videoWitnessPlugin",null,null,param);
		layerUtils.iLoading(false);
	}
	
    function destroy()
    {
        service.destroy();
    }

    /* 初始化页面 */
    function initPage()
    {
      
 //       needVideo = appUtils.getPageParam("need_video");
 //       needInfo =  appUtils.getPageParam("needInfo");
       
	    videoParam = appUtils.getSStorageInfo("videoParam");
	    videoParam = JSON.parse(videoParam);
        if(videoParam.need_video == 1){
            $(".icon_back",_pageId).hide();
	        if(videoParam["needInfo"] =="身份证照片驳回，请重新上传身份证照片" || videoParam["needInfo"] =="姓名关键信息驳回，请修改个人资料")
	        {
	             $(_pageId+" .main .step_box").show();
	             $(_pageId+" .error_notice").show();
	        }
	        else{
	            $(_pageId+" .main .step_box").hide();
	            $(_pageId+" .error_notice").show();
	            $(_pageId+" h5").html("驳回理由："+videoParam.needInfo);
	            }
        }else{
           queryQQOfflineState();
        }
     //判断是否做过视频
      
    }

    /* 获取营业部视频端口 */
    function getVedioport()
    {
        //获取营业部视频端口
        var param={
            "branchno":appUtils.getSStorageInfo("branchno"),
            "userid":appUtils.getSStorageInfo("user_id")
        };
        service.queryVideoAddress(param,function(data){
            if(data.error_no=="0" && data.results.length != 0)
            {
                appUtils.setSStorageInfo("branch_id",data.results[0].branch_id);
                appUtils.setSStorageInfo("branch_url",data.results[0].url);
                // 如果是从短信验证码页面跳转过来的，从 session 中取 QQ 号并填充
                if(appUtils.getSStorageInfo("_prePageCode") == "account/msgVerify")
                {
                    queryQQOfflineState();
                }
                //如果是从回访页面跳转过来的，判断是否进行双向视频验证
                else if(appUtils.getSStorageInfo("_prePageCode") == "account/openConfirm")
                {
                    queryQQOfflineState();
                }
                 else if(appUtils.getSStorageInfo("_prePageCode") == "account/riskAssessment")
                {
                    queryQQOfflineState();
                }
            }
            else
            {
                layerUtils.iMsg(-1,"获取视频服务器IP端口异常");  //提示错误信息
            }
        },true,true,handleTimeout);
    }

    /* 处理返回按钮 */
    function pageBack()
    {
        var currentStep = appUtils.getSStorageInfo("currentStep");
        var isNeedConfirm =  appUtils.getSStorageInfo("isNeedConfirm"); 

       // 从短信登陆进入(当前完成步骤为：已经完成回访问卷)，处理返回按钮
        if(isNeedConfirm==0)
        {    
            appUtils.setSStorageInfo("currentStep","witness"); 
             appUtils.setSStorageInfo("visitsurvey","exist"); // 标记完成回访问卷
            appUtils.pageInit("account/videoNotice","account/openConfirm");
        }
        else
        {
            appUtils.pageInit("account/videoNotice","account/riskAssessment");
        }
    }

    /* 处理请求超时 */
    function handleTimeout()
    {
        layerUtils.iConfirm("请求超时，是否重新加载？",function(){
            getVedioport();  // 再次获取视频端口
        });
    }

    /* 查询离线视频通过状态 */
    function queryQQOfflineState()
    {
        var lookVedioStateParam = {
            "user_id" : appUtils.getSStorageInfo("user_id")
        };
        service.queryQQOfflineState(lookVedioStateParam,function(data){
            var error_no = data.error_no;
            var error_info = data.error_info;
            if(error_no == 0 && data.results.length != 0)
            {
                // 视频通过状态，0：未见证、2：已预约离线见证未完成见证、1：视频见证完成、3：见证失败
                // 未见证不需要做处理
                var witnessFlag = data.results[0].witness_flag;
                if(witnessFlag == 1) {
                //   layerUtils.iAlert("您的视频见证已通过！",0);
                    layerUtils.iLoading(true,'您的视频见证已通过!');
                        //若不需要安装证书，直接跳转到开户完成页面
                    videoNextStep();  
                }
                else if(witnessFlag == 2)
                {
                    layerUtils.iAlert("您的预约信息已经提交，我们的客服将尽快联系您！",0);
                }
                else if(witnessFlag == 3)
                {
                 
                    layerUtils.iAlert("视频见证失败，请重新预约！");
                }
            }
            else
            {
                layerUtils.iAlert(data.error_info);
            }
        });
    }

    /* 见证通过 */
    function videoSuccess()
    {
    	console.log("videoSuccess");
        layerUtils.iLoading(true,'您的视频见证已通过……');
            layerUtils.iLoading(false);
            //若不需要证书，跳转到开户完成页面，否则跳转到回访页面
            videoNextStep();
        
    }

  //设置下一步
    function videoNextStep(){
       
       videoParam = appUtils.getSStorageInfo("videoParam");
       videoParam = JSON.parse(videoParam);
       		  if(videoParam.need_video == 1){
          //调用提交补全资料接口
			var notifyParam = {
				"userid" : appUtils.getSStorageInfo("user_id"),
				 "fieldname" : "workflowagain"  // 通知视频已补全
			};
			service.rejectStep(notifyParam,function(data){
				if(data.error_no == 0)
				{
				    appUtils.setSStorageInfo("isBack", "backInfo");  //标志重新提交资料成功
			        appUtils.pageInit("account/videoNotice","account/accountResult",{});
			       
	            }
	            else{
	                layerUtils.iAlert(data.error_info);
		            layerUtils.iLoading(false);
	            }
          })
       }else{
			appUtils.pageInit("account/videoNotice","account/accountResult",{});
        }
    }
	
	function videoReject(flag){
		console.log("videoReject");
			if(flag=="SYS:10011"){
			   var  photoFlag = {"photoFlag" : "SYS:10011"};	   
		       appUtils.setSStorageInfo("photoFlag",JSON.stringify(photoFlag));
			   appUtils.pageInit("account/videoNotice","account/uploadPhoto",photoFlag);
			}
			else if(flag=="SYS:10012"){
			   var fillInformationInParam = {"custname" :appUtils.getPageParam("custname"), // 客户姓名
					"ethnicname" :appUtils.getPageParam("ethnicname"), //民族
					"idno" : appUtils.getPageParam("idno"), // 身份证号
					"policeorg" :appUtils.getPageParam("policeorg"), // 签发机关
					"native" :appUtils.getPageParam("native"),// 证件地址
					"native" :appUtils.getPageParam("native"),// 联系地址和证件地址设置相同的
					"idbegindate" :appUtils.getPageParam("idbegindate"), //起始期限
					"idenddate" :appUtils.getPageParam("idenddate"),//结束期限
					"postid" :appUtils.getPageParam("postid"), //邮编
				 	"personinfoFlag" : "SYS:10012"
				 }
	//		   var  personinfoFlag = {
	//		       "fillInformationInParam":fillInformationInParam
	//		       };
			   appUtils.pageInit("account/videoNotice","account/personInfo",fillInformationInParam);
			  
			}
			else if(flag=="SYS:10001"){
				layerUtils.iAlert("见证失败，请重新见证");
			}
			else{
				layerUtils.iAlert("见证失败，请重新见证");
			}
	}
	
    /* 见证不通过 */
    function videoFail(){
    	console.log("videoFail");
    }

    var videoNotice = {
        "init" : init,
        "bindPageEvent" : bindPageEvent,
        "pageBack" : pageBack,
        "destroy" : destroy
    };

    // 暴露对外的接口
    module.exports = videoNotice;
});