﻿/**
 * 手机开户2.0
 */
define("project/scripts/business/index",function(require, exports, module){ 
	/* 私有业务模块的全局变量 begin */
	var appUtils = require("appUtils"),
		service = require("serviceImp").getInstance(),  //业务层接口，请求数据
		layerUtils = require("layerUtils"),
		shellPlugin = require("shellPlugin"),
		_pageId = "#business_index";
	/* 私有业务模块的全局变量 end */
	
	function init()
	{
		appUtils.clearSStorage();

		// 自动测速，选择最佳地址
		// 启动时，检查当前客户端的版本号与服务器上最新的是否一致，根据需要更新客户端，只在启动时检查
		// started 为 true 表示已启动，已启动就不检查
		if(appUtils.getSStorageInfo("started") != "true")
		{
			// 设置 session 中的 started 为 true ，表示已启动
			appUtils.setSStorageInfo("started","true");
			layerUtils.iLoading(true,'初始化版本...');
			setBestAddress();
		}
	}
	
	function bindPageEvent(){
		
		/* 绑定新开账户  */
		appUtils.bindEvent($(_pageId+" .home_nav .open"),function(){
			// 设置标识'new',表示新开户,并且存到local
			appUtils.setSStorageInfo("openChannel","new");
			appUtils.pageInit("business/index","account/msgVerify",{});
		});
		
		/* 绑定理财账户 */
		appUtils.bindEvent($(_pageId+" .home_nav .open_finance"),function(){
			// 设置标识'new',表示新开户,并且存到local
			appUtils.setSStorageInfo("openChannel","change");
			appUtils.setSStorageInfo("finance","finance");
			appUtils.pageInit("business/index","account/msgVerify",{});
		});
		
		/* 绑定转户 */
		appUtils.bindEvent($(_pageId+" .home_nav .change"),function(){
			// 设置标识'new',表示新开户,并且存到local
			appUtils.setSStorageInfo("openChannel","change");
			appUtils.pageInit("business/index","account/msgVerify",{});
		});
		
		/* 切换蓝色风格 */
		appUtils.bindEvent($(_pageId+" #blue"),function(){
			$(this).addClass("active").siblings(this).removeClass("active");
			loadCSS("#blue","../m/project/css/style.css");
		});
		
		/*切换黄色风格 */
		appUtils.bindEvent($(_pageId+" #yellow"),function(){
			$(this).addClass("active").siblings(this).removeClass("active");
			loadCSS("#yellow","../m/project/css/style_yintai.css");
		});
		
		/* 切换黑色风格 */
		appUtils.bindEvent($(_pageId+" #black"),function(){
			$(this).addClass("active").siblings(this).removeClass("active");
		});
	}
	
	function destroy(){

    }
	
	/* 动态加载css */
	function loadCSS(id, fileUrl) 
	{
	    var cssTag = document.getElementById(id),
	    	  oHead = document.getElementsByTagName('head').item(0),
	    	  ocss= document.createElement("link");
	    if(id == "#blue")
	    {
	    	oHead.removeChild(document.getElementById("#yellow"));
	    }
	    else
	    {
	    	if (cssTag) oHead.removeChild(cssTag); 
		    ocss.id= id;
		    ocss.href = fileUrl; 
		    ocss.rel = "stylesheet"; 
		    ocss.charset= "uf-8";
	    	oHead.appendChild(ocss); 
	    }
	}
	
	/* 自动测速，选择最佳地址 */
	function setBestAddress()
	{
		// 在启动时，首先选择网速最优的地址,key 测试地址，value 服务地址
//		var addressMap = {
//				"119.145.1.145" : "119.145.1.155:8088",
//				"58.251.38.39" : "58.251.38.52:8088"
//			},
//			bestAddressParam = {
//				"urlArray" : ["119.145.1.145","58.251.38.39"]
//			};
//		shellPlugin.callShellMethod("speedServerPlugin",function(data){
//			// 取映射中的服务地址
//			var serverAddress = addressMap[data.urlArray[0]];
//			// 在壳子里面设置 serverPath 会影响全局，但是浏览器不行，因为浏览器有刷新功能
//			global.serverPath = "http://"+serverAddress+"/servlet/json";
//			global.serverPathTrade = "http://"+serverAddress+"/servlet/trade/json";
//			global.ticketImage = "http://"+serverAddress+"/servlet/Image";
//			detectUpdate();
//		},null,bestAddressParam);
		//检测更新最新版本
		detectUpdate();
	}
	
	/* 检测更新最新版本 */
	function detectUpdate()
	{
		// 获取客户端的版本号
		var vesionStr = null;
		shellPlugin.callShellMethod("getVersionPlugin",function(data){
			vesionStr = data.version;
			// 查询服务器上最新的版本号
			var queryParam = {"terminal_type" : "android"}; // 类型
			detectNetWork();  // 检查网络
			service.getVersion(queryParam,function(data){
				if(data.error_no == 0)
				{
					layerUtils.iLoading(false);
					execUpdate(data);  // 更新最新版本
				}
				else
				{
					layerUtils.iLoading(false);
				}
			},true,false);
		},function(){return false;},{});
	}
	
	/* 检测网络是否可用 */
	function detectNetWork()
	{
		// 插件中全局的断网监听也会执行，让首页的断网监听在全局断网之后执行
		setTimeout(function(){
			// 发请求之前，检测网路是否存在，存在--发请求
			shellPlugin.callShellMethod("isNetAvailablePlugin",function(data){
				if(data.available == "false")
				{
					layerUtils.iAlert("请检查网络是否正常!",-1,function(){return false;
						shellPlugin.callShellMethod("closeAppPlugin",null,null);
					});
				}
			},null,{});
		},1000);
	}
	
	/* 执行更新操作 */
	function execUpdate(data)
	{
		var updateParam = {
			"url" : data.results[0].update_url,  // 更新地址
			"versionLatest" : data.results[0].version,  // 最新版本号
			"versionLowest" : data.results.length == 2 ? data.results[1].version : "0"  // 强制更新最低版本号，只有一条记录时，界限版本传 0 ，表示不需要强制更新
		};
		shellPlugin.callShellMethod("updateManagerPlugin",null,null,updateParam);
	}
	
	var index = {
		"init" : init,
		"bindPageEvent" : bindPageEvent,
		"destroy" : destroy
	};
	
	module.exports = index;
});